rem RPC-52 Keypad and graphics display demo program
rem Will also work with RPC-320.  Need to perform a CONFIG DISPLAY xxx
rem before writing to display.

10 clear display

rem print out intro

20 display "Graphics display and"
30 display (1,0),"keypad program."
40 display (3,0),"Keypress no:"
50 display (4,0),"Keypad char:"
60 display (6,0,off), "    Graphics demo"
70 print "Graphics display and keypad demo program"
80 print "Pressing a keypad will return its position and character"
90 print "to the graphics display."

rem set up keypad check timer and strings

100 string 200,30
110 ontick .1,1000
120 $(0)="123A456B789C*0#DEFGHIJKL"  :rem initialize keypad string
130 asc($(1),2) = 13		:rem force end of string character
180 print 
190 print "To stop program, press <Ctrl>-C"

rem print graphics demo

200 display (8,0),"Line drawing  "
210 display line (0,100)-(60,80)
220 display line (60,80)-(70,127)

rem can assign variables to lines also

230 x1 = 70
240 x2 = 100
250 y1 = 127
260 y2 = 70
270 display line (x1,y1)-(x2,y2)

rem delay for a bit

300 gosub 2000

400 display (8,0),"Pixel drawing"
410 clear tick(1)
420   X1=0 : REM starting data plot x point
430   X2=5 : REM starting line erase x point
450 do

520   Y=SIN(B)*30+93 : REM The Y value is what is plotted.
530    DISPLAY P(X1,Y) : rem put out the point
540    CLEAR  DISPLAY LINE(X2,63)-(X2,127) : rem erase old data
550   B=B+.1 : REM next sine point
560   X1=X1+1 : rem update x data point
570    IF X1=160 THEN X1=0  : REM if at end of graph, wrap to start
580   X2=X2+1 : rem update x erase point
590    IF X2=160 THEN X2=0 : REM if at end of display graph, wrap 

600 until tick(1) > 15

610 clear display g
650 goto 200

990 end

1000 rem keypad check timer
1010 a = keypad(0)		:rem get keypad character
1020 if a = 0 then reti		:rem if a = 0, then no char pressed
1030 asc($(1),1) = asc($(0),a)	:rem convert position to character
1040 display (4,13),$(1)	:rem print keypad character

rem convert position to a printable number

1100 c = int(a/10)		:rem figure first position
1110 $(2) = "  "		:rem initialize position string
1120 if c = 0 then 1150		:rem if 0-9, skip first digit
1130 asc($(2),1) = c .or. 48	:rem put in ascii of number

1150 a = a-c*10			:rem figure 1's of number
1160 asc($(2),2) = a .or. 48
1170 display(3,13),$(2)

1200 reti




2000 clear tick(0)
2010 if tick(0) < 1 then 2010
2020 return
