rem  Centronics printer demo program for RPC-320
rem  This is not bi-directional and shouldn't be.

Rem Uses Digital I/O port J3

Rem General port usage is as follows:
Rem	Port A - data output
Rem	Port C - Paper empty, off-line detect, strobe
Rem	Port B - high current not used for this demo

Rem Port A pin assignments
Rem 	J3 Line #	Data/Function		DB-25 printer pin #
rem						(to printer)

rem	19		D0  printer data	2
rem	21		D1			3
rem	23		D2			4
rem	25		D3			5
rem	24		D4			6
rem	22		D5			7
rem	20		D6			8
rem	18		D7			9

rem	Control line output from Port C

rem	9		D7/Strobe, bit 7	1
rem	12		D6/Init, bit 6		16
rem	11		D5/Slct In, bit 5	17

rem	Printer status input to Port C

rem	13		D0/Busy, bit 0		11
rem	16		D1/Paper, bit 1		12

rem Other inputs and outputs can be added as needed

10 rem Centronics printer demo
20 rem Conifigure J3 for Port A - out, B - out, upper C Out, Lower C - in
30 rem
40 config line 100,1,0,0,1
50 rem
60 rem Set up string space.  Adjust as necessary for application
70 string 1040,82  :rem for 80 collumn printer

rem initialize printer control lines

80 line#109,1	:rem strobe
90 line#112,off	:rem initialize/reset printer
100 line#112,on

rem demo requests a string from the main input and then prints it

200 print
210 print "Print demo program."
220 input "Enter a string to print:",$(0)
230 gosub 1000

500 end


1000 rem print out the printer port
1010 rem This subroutine automatically prints a <CR><LF> sequence

1020 rem Check if paper out
1030 rem If so, print message and bail out

1040 b=line#(116)
1050 if b = 1 then print "Out of paper":return

1070 rem String $(0) is printed
1080 rem Make output loop length of string

1100 for x = 1 to str(0,$(0))
1120   	a = asc($(0),x) : rem get value of character to output

rem waits until printer is ready.  May want a timout loop here using TICK

1130 rem check status of printer
1140   	b = line#(113)
1150   	if b <> 0 then 1140  :rem wait until printer ready.

1160    gosub 1500 : rem call general output 
1180 next

1200 rem output CR LF
1210 a = 10
1220 gosub 1500
1230 a = 13
1240 gosub 1500

1290 return

rem general output routine

1500   	lineb 3,0,a :rem output the data
1510	line# 109,0  :rem strobe data into printer
1520 	line# 109,1
1530	return
