REM RPBASIC-52 program to display time on LCD-5003 clock.

10 display (4,7,off),"ROLL EX"
20 display (0,9),"12",(0,14),"1",(3,17),"2",(15,5),"7"
30 display (8,18),"3",(12,17),"4",(15,14),"5",(15,10),"6"
40 display (12,2),"8",(8,1),"9",(3,1),"10",(0,4),"11"
50 clear display g

60 x1 = 80 : y1 = 64
70 pa = 2*pi/60
80 s = 1

rem figure position of minutes and hours

100 gosub 4000
100 oh = nh
110 om = nm
120 os = ns
130 xm = int(cos(nm*pa)*50+x1+.5)
140 ym = int(sin(nm*pa)*50+y1+.5)
150 xh = int(cos(nh*pa)*40+x1+.5)
160 yh = int(sin(nh*pa)*40+y1+.5)

rem draw hours and minutes on screen

200 display line(x1,y1)-(xm,ym)
210 display line(x1+2,y1)-(xm,ym)
220 display line(x1-2,y1)-(xm,ym)

230 display line(x1,y1+2)-(xm,ym)
240 display line(x1,y1-2)-(xm,ym)

250 display line(x1,y1)-(xh,yh)
260 display line(x1+2,y1)-(xh,yh)
270 display line(x1-2,y1)-(xh,yh)

280 display line(x1,y1+2)-(xh,yh)
290 display line(x1,y1-2)-(xh,y1)


300 clear tick(0)
310 ontick 1,1000

rem Idle wait

400 goto 400

rem Update drawing here

rem clear old seconds

1000 clear display line (x1,y1)-(xs,ys)

rem get new time and figure coords for hours, minutes, and seconds

1010 gosub 4000

1100 display line(x1,y1)-(xs,ys)


1200 if om = nm then 1500
1220 xm = int(cos(om*pa)*50+x1+.5)
1240 ym = int(sin(om*pa)*50+y1+.5)
1250 clear display line(x1,y1)-(xm,ym)
1260 clear display line(x1+2,y1)-(xm,ym)
1270 clear display line(x1-2,y1)-(xm,ym)
1280 clear display line(x1,y1+2)-(xm,ym)
1290 clear display line(x1,y1-2)-(xm,ym)

rem figure new x,y positions and draw them

1300 xm = int(cos(nm*pa)*50+x1+.5)
1310 ym = int(sin(nm*pa)*50+y1+.5)

1320 display line(x1,y1)-(xm,ym)
1330 display line(x1+2,y1)-(xm,ym)
1340 display line(x1-2,y1)-(xm,ym)
1350 display line(x1,y1+2)-(xm,ym)
1360 display line(x1,y1-2)-(xm,ym)
1400 om = nm

rem check on hours

1500 if oh = nh then reti
1510 xh = int(cos(oh*pa)*40+x1+.5)
1520 yh = int(sin(oh*pa)*40+y1+.5)
1530 clear display line(x1,y1)-(xh,yh)
1540 clear display line(x1+2,y1)-(xh,yh)
1550 clear display line(x1-2,y1)-(xh,yh)
1560 clear display line(x1,y1+2)-(xh,yh)
1570 clear display line(x1,y1-2)-(xh,yh)

rem figure new x,y positions and draw them

1600 xh = int(cos(nh*pa)*40+x1+.5)
1610 yh = int(sin(nh*pa)*40+y1+.5)

1620 display line(x1,y1)-(xh,yh)
1630 display line(x1+2,y1)-(xh,yh)
1640 display line(x1-2,y1)-(xh,yh)
1650 display line(x1,y1+2)-(xh,yh)
1660 display line(x1,y1-2)-(xh,yh)
1700 oh= nh

1800 reti


rem Calculate x and y positions for seconds

4000 nh = time(0)
4010 nm = time(1)
4020 ns = time(2)

4140 xs = int(cos(ns*pa)*60+x1+.5)
4150 ys = int(sin(ns*pa)*60+y1+.5)
4190 return
