rem RPC-52 demonstration program
rem Can use RPC-320 if CONFIG DISPLAY 3 is included in program

10 REM OPTREX DMF-5003 display demo program
20 REM writes characters and draws lines to display
30 REM date this edit: 10-13-92
40 REM define ports and addresses
50 cp = 2  :REM control port
60 dp = 0  :REM data port
70 tx = 1  :REM text pointer x position
80 ty = 1  :REM text position y
90 cu = 0  :REM cursor on/off
100 cs = 1 :REM cursor size


1000 REM initialize I/O port and reset display
1010 gosub 7000
1020 dc = 80h  :REM command word to mode set OR
1030 gosub 5000
1040 REM put into text mode
1050 gosub 7500

1060 dc = 94h  :REM  turn on text
1070 gosub 5000

1100 REM  write out some text
1110 for x = 0 to 70
1120    d1 = x  :REM  set character to write
1130    gosub 5500
1140    dc = 0c0h
1150    gosub 5000
1160 next

1200 dc = 94h  :REM  turn on text
1210 gosub 5000

4990 end

5000 REM cwrt
5010 REM  Write command  using variable dc
5020 REM  set up c/d* line first before other writes
5030 lineb 4,1,6ch : rem     01101100
5040 REM  DC is the data to write to
5050 lineb 4,0,dc
5060 lineb 4,1,0e4h :REM  CE and WR low, others high  11100100
5080 lineb 4,1,2ch  :REM  set to data input 00101100
5090 return


5500 REM dwrt
5510 REM  write data
5520 REM  assume c/d* line is low
5530 REM  D1 is data to write to
5540 lineb 4,0,d1
5550 lineb 4,1,0a4h  :REM  CE, WR, and C/D low, RD high 10100100
5560 lineb 4,1,02ch  :REM  set to data input
5570 return


7000 REM init
7010 REM  initialize display
7100 return


7500 REM tmset
7510 REM  set into text mode
7520 REM  text home address (in RAM) for first character = 1000
7530 d1 = 0
7540 gosub 5500
7550 d1 = 10h
7560 gosub 5500
7570 dc = 40h  :REM  command for text home address
7580 gosub 5000

7600 REM set up text area (number of characters in 1 row)
7620 REM  for 5003, this is 20
7630 d1 = 20
7640 gosub 5500
7650 d1 = 0  :REM  this is usually always 0
7660 gosub 5500
7670 dc = 41h  :REM  commmand for set up text area
7680 gosub 5000

7700 REM  Set character address pointer to 1000h
7710 d1 = 0  :REM  address of where data is written to (like an offset ptr)
7720 gosub 5500
7730 d1 = 10h  
7740 gosub 5500
7750 dc = 24h  :REM  address pointer set command
7760 gosub 5000

7900 return

8000 REM gmset
8010 REM  graphics mode set
8020 REM  set graphics RAM memory location (first address)
8030 d1 = 0
8040 gosub 5500
8050 d1 = 5  :REM  corresponds to 500H
8060 gosub 5500
8070 dc = 42h
8080 gosub 5000

8100 REM Define graphic bytes in one graphic row
8110 d1 = 20  :REM  160 dots / 8 = 20
8120 gosub 5500
8130 d1 = 0
8140 gosub 5500
8150 dc = 43h
8160 gosub 5000

8200 REM  set the address pointer
8210 d1 = 0 
8220 gosub 5500
8230 d1 = 5
8240 gosub 5500
8250 dc = 24h
8260 gosub 5000


8400 return


8800 REM clstxt
8810 REM  clear text screen and home cursor
8820 gosub 7500
8830 REM  clear out all characters for this display
8840 REM  turn on automatic writing mode
8850 d1 = 0b0h
8860 gosub 5000
8870 d1= 0

8880 for x = 1 to 320
8890   gosub 5500
8900 next
8910 dc = 0b2h  :REM  turn off autowrite
8920 gosub 5000
8930 gosub 7500
8950 return

9000 REM locate
9010 REM  positions cursor at specified TX and TY 
9020 REM  optionally turns on cursor CU = 0 = off
