rem Fast cursor control demonstration
rem This program may be downloaded directly to the RPC-52 card.
rem Can use with RPC-320 card.  

rem Use this program with LCD character displays (only) to control
rem the blinking speed.  Another character besides a solid block (no 255)
rem can be used (such as an underline, character number 95)

rem ONTICK must be dedicated to this task unless the blink rate happens
rem to correspond to some process.  A blinking cursor could also be used
rem to indicate that a process is actually taking place.  The rate the
rem cursor blinks indicates how long a cycle takes.  In that case, you 
rem should not use ONTICK as a timer.

rem The cursor position accessed using the XBY function.  The row is
rem at 237H while the current column is at 239H.

rem The program below keeps the cursor at the current location.  Remember,
rem if you use the data option in DISPLAY, the cursor position is not
rem updated.

REM set blink rate

10     ONTICK .25,200	

rem Set the cursor to some arbitrary place and turn it off

20     DISPLAY (1,15,off)

rem Loop here

30     GOTO 30

rem blink interrupt
rem Get current cursor position

200 y = xby(237h) : rem row
210 x = xby(239h) : rem column

rem Toggle cursor according to last state
rem Variable A is used for this

220    IF A=0 THEN  DISPLAY 32,(y,x)
230    IF A=1 THEN  DISPLAY 255,(y,x)

rem toggle cursor state

240    IF A=0 THEN A=1 ELSE A=0
250    RETI 

