rem Display point and erase demonstration
rem A sine wave is displayed on the lower part of the 
rem LCD5003.  The upper part may have text or other graph info.

rem As the sine wave moves continiously across, old data is
rem erased with the CLEAR DISPLAY LINE statement, creating the illusion of
rem an "erase bar".  CLEAR DISPLAY LINE statement is 6
rem points ahead of the newest value.  The break between
rem old and new data is where data is currently at.

rem This kind of graphics updating is faster than redrawing the entire
rem screen every time a new point is entered.

rem X2 is the number of pixels from the new data point.  Adjust this point
rem if the "erase bar" display does not look

90 display (0,0,off)  : rem turn off cursor
100   X1=0 : REM starting data plot x point
110   X2=5 : REM starting line erase x point
120   Y=SIN(B)*34+93 : REM The Y value is what is plotted.
130    DISPLAY P(X1,Y) : rem put out the point
140    CLEAR  DISPLAY LINE(X2,63)-(X2,127) : rem erase old data
150   B=B+.1 : REM next sine point
160   X1=X1+1 : rem update x data point
170    IF X1=160 THEN X1=0  : REM if at end of graph, wrap to start
180   X2=X2+1 : rem update x erase point
190    IF X2=160 THEN X2=0 : REM if at end of display graph, wrap 
200    GOTO 120 : rem reloop for this demo
