
There are two memory locations you can check to detect a continious 
keypad press.

External memory address location 22DH returns a 3 when a key is debounced 
and pressed and 0 when released.  Location 22CH returns a "raw" key 
position pressed.

The following is a short example of how this works:

	10	A=KEYPAD(0)		get character from keypad buffer
	20	IF A = 0 then 10	wait until there is one in buffer

	30	B=XBY(22DH)		Get key press status
	40	C=XBY(22CH)		Get raw key press information
	50 	PRINT A,B,C

	60	CLEAR TICK(0)		Set up delay for printing so data does not
	70  	IF TICK(0) < .1 THEN 70	scroll by too fast.  Not necessary for monitoring.

	80	IF B = 0 then 10

This program prints out the keypad status.  You may want to monitor 
address 22CH in case someone "fat fingers" the keypad by pressing a 
second key before releasing the first one.

